﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TIS.Imaging;
using static System.Net.Mime.MediaTypeNames;
namespace ICWPF_VideoWindow
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		private TIS.Imaging.ICImagingControl _ic = new TIS.Imaging.ICImagingControl();
        private FrameFilter _rotateFlipFilter ;
		public MainWindow()
		{
			InitializeComponent();
            _rotateFlipFilter = _ic.FrameFilterCreate("Rotate Flip", "");
            _ic.DeviceFrameFilters.Add(_rotateFlipFilter);
            _ic.Sink = new FrameQueueSink(ShowBuffer, MediaSubtypes.RGB32, 5);
		}

        private FrameQueuedResult ShowBuffer(IFrameQueueBuffer buffer)
        {
            
            //videoWindow1にカメラの画像を表示
            videoWindow1.UpdateImage(buffer);
            //TIS.Imaging.FrameExtensions.SaveAsTiff(buffer, "RGB64.tiff");

            return FrameQueuedResult.ReQueue;
        }

		private void chkFlipH_Checked(object sender, RoutedEventArgs e)
		{
			videoWindow1.FlipH = chkFlipH.IsChecked.Value;
         
        }

		private void chkFlipV_Checked(object sender, RoutedEventArgs e)
		{
			videoWindow1.FlipV = chkFlipV.IsChecked.Value;
		}

		private void chkFlipH_Unchecked(object sender, RoutedEventArgs e)
		{
			videoWindow1.FlipH = chkFlipH.IsChecked.Value;
		}

		private void chkFlipV_Unchecked(object sender, RoutedEventArgs e)
		{
			videoWindow1.FlipV = chkFlipV.IsChecked.Value;
		}

        ///

        private void chkRotateFlipH_Checked(object sender, RoutedEventArgs e)
        {
            _rotateFlipFilter.SetBoolParameter("Flip H", chkRotateFlipH.IsChecked.Value);
        }
        private void chkRotateFlipH_Unchecked(object sender, RoutedEventArgs e)
        {
            _rotateFlipFilter.SetBoolParameter("Flip H", chkRotateFlipH.IsChecked.Value);
        }
        private void chkFlipRotateV_Checked(object sender, RoutedEventArgs e)
        {
            _rotateFlipFilter.SetBoolParameter("Flip V", chkRotateFlipV.IsChecked.Value);
        }
        private void chkFlipRotateV_Unchecked(object sender, RoutedEventArgs e)
        {
            _rotateFlipFilter.SetBoolParameter("Flip V", chkRotateFlipV.IsChecked.Value);
        }

        private void btnSelectDevice_Click(object sender, RoutedEventArgs e)
		{
			_ic.LiveStop();

            //_ic.ShowDeviceSettingsDialog();
            _ic.LoadShowSaveDeviceState("lastSelectedDeviceState.xml");

            if ( _ic.DeviceValid )
			{
                string videoformat = _ic.VideoFormat;
                int index = videoformat.IndexOf('(');
                string beforeParenthesis = "";
                if (index >= 0)
                {
                    beforeParenthesis = videoformat.Substring(0, index).Trim();
                }
                else
                {
                    Console.WriteLine("( が見つかりませんでした。");
                }


                if (beforeParenthesis == "RGB24")
                {
                    _ic.Sink = new FrameQueueSink(ShowBuffer, MediaSubtypes.RGB24, 5);
                }
                else if (beforeParenthesis == "RGB32")
                {
                    _ic.Sink = new FrameQueueSink(ShowBuffer, MediaSubtypes.RGB32, 5);
                }
                else if (beforeParenthesis == "RGB64")
                {
                    _ic.Sink = new FrameQueueSink(ShowBuffer, MediaSubtypes.RGB64, 5);
                }
                else if (beforeParenthesis == "Y16")
                {
                    _ic.Sink = new FrameQueueSink(ShowBuffer, MediaSubtypes.Y16, 5);
                }
                else if (videoformat == "Y800")
                {
                    _ic.Sink = new FrameQueueSink(ShowBuffer, MediaSubtypes.Y800, 5);
                }
                else
                {
                    _ic.Sink = new FrameQueueSink(ShowBuffer, MediaSubtypes.RGB24, 5);
                }

                _ic.LiveStart();
			}

		}



    }
}
